﻿
using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;
using Wisej.Web;
using WisejWebPageApplication1.Models;

namespace WisejWebPageApplication1
{
    public partial class Page1 : Page
    {
        private List<ViewPratiche> dataSource1 = new List<ViewPratiche>();
        private List<ViewPratiche> dataSource2 = new List<ViewPratiche>();
        private List<ViewPratiche> dataSource3 = new List<ViewPratiche>();

        public Page1()
        {
            InitializeComponent();
        }

        private void Page1_Load(object sender, EventArgs e)
        {
            LoadDataSource(dataSource1);
            LoadDataSource(dataSource2);
        }

        private void LoadDataSource(List<ViewPratiche> toLoad)
        {
            Random random = new Random();
            toLoad.Clear();

            for (int i = 0; i <= 10000; i++)
            {
                toLoad.Add(new ViewPratiche()
                {
                    StatoPratica = random.Next(int.MinValue, int.MaxValue).ToString()
                });
            }
        }

        private void SetDataSource(DataGridView grid, object dataSource)
        {
            lock (grid)
            {
                grid.BeginUpdate();
                grid.DataSource = null;
                grid.DataSource = dataSource;
                grid.EndUpdate();
            }
        }

        private void ResetDataSource()
        {

            Application.StartTask(() =>
            {
                Application.Update(gridPratiche, () =>
                {
                    LoadDataSource(dataSource1);
                    SetDataSource(gridPratiche, dataSource1);
                });
            });

            Application.StartTask(() =>
            {
                Application.Update(gridPratiche, () =>
                {
                    LoadDataSource(dataSource2);
                    SetDataSource(gridPratiche, dataSource2);
                });
            });

            Application.StartTask(() =>
            {
                Application.Update(gridPratiche, () =>
                {
                    LoadDataSource(dataSource3);
                    SetDataSource(gridPratiche, dataSource3);
                });
            });
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            ResetDataSource();
        }
    }
}
